package com.qmth.distributed.print.business.bean.params;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import com.qmth.distributed.print.business.entity.ExamTaskDetail;
import com.qmth.teachcloud.common.base.BaseEntity;
import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 命题任务
 * </p>
 *
 * @author xf
 */
public class ExamTaskApplyPram extends BaseEntity implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "命题任务ID")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long examTaskId;

    @ApiModelProperty(value = "命题任务详情")
    private List<ExamTaskDetail> examTaskDetailList;

    /**
     * 保存内容
     */
    private String examTaskContent;

    @ApiModelProperty(value = "流程审批人列表")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(exist = false)
    private List<Long> approveUserIds;

    @ApiModelProperty(value = "自定义流程id")
    @JsonSerialize(using = ToStringSerializer.class)
    @TableField(exist = false)
    private Long customFlowId;

    @ApiModelProperty(value = "版本号")
    @TableField(exist = false)
    private Integer version;

    public Long getExamTaskId() {
        return examTaskId;
    }

    public void setExamTaskId(Long examTaskId) {
        this.examTaskId = examTaskId;
    }

    public List<ExamTaskDetail> getExamTaskDetailList() {
        return examTaskDetailList;
    }

    public void setExamTaskDetailList(List<ExamTaskDetail> examTaskDetailList) {
        this.examTaskDetailList = examTaskDetailList;
    }

    public String getExamTaskContent() {
        return examTaskContent;
    }

    public void setExamTaskContent(String examTaskContent) {
        this.examTaskContent = examTaskContent;
    }

    public List<Long> getApproveUserIds() {
        return approveUserIds;
    }

    public void setApproveUserIds(List<Long> approveUserIds) {
        this.approveUserIds = approveUserIds;
    }

    public Long getCustomFlowId() {
        return customFlowId;
    }

    public void setCustomFlowId(Long customFlowId) {
        this.customFlowId = customFlowId;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }
}
