package com.qmth.teachcloud.mark.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.qmth.teachcloud.mark.entity.MarkQuestionAnswer;
import com.qmth.teachcloud.mark.mapper.MarkQuestionAnswerMapper;
import com.qmth.teachcloud.mark.service.MarkQuestionAnswerService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.teachcloud.mark.service.MarkQuestionService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 客观题信息 服务实现类
 * </p>
 *
 * @author xf
 * @since 2024-10-16
 */
@Service
public class MarkQuestionAnswerServiceImpl extends ServiceImpl<MarkQuestionAnswerMapper, MarkQuestionAnswer> implements MarkQuestionAnswerService {

    @Override
    public void deleteByExamIdAndPaperNumberAndMainNumberAndSubNumber(Long examId, String paperNumber, Integer mainNumber, Integer subNumber) {
        UpdateWrapper<MarkQuestionAnswer> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().eq(MarkQuestionAnswer::getExamId, examId)
                .eq(MarkQuestionAnswer::getPaperNumber, paperNumber)
                .eq(MarkQuestionAnswer::getMainNumber, mainNumber)
                .eq(MarkQuestionAnswer::getSubNumber, subNumber);
        this.remove(updateWrapper);
    }

    @Override
    public void resetObjectivePolicyByExamIdAndPaperNumberAndMainNumberAndSubNumber(Long examId, String paperNumber, Integer mainNumber, Integer subNumber) {
        UpdateWrapper<MarkQuestionAnswer> updateWrapper = new UpdateWrapper<>();
        updateWrapper.lambda().set(MarkQuestionAnswer::getAnswer, null)
                .set(MarkQuestionAnswer::getObjectivePolicy, null)
                .set(MarkQuestionAnswer::getObjectivePolicyScore, null)
                .eq(MarkQuestionAnswer::getExamId, examId)
                .eq(MarkQuestionAnswer::getPaperNumber, paperNumber)
                .eq(MarkQuestionAnswer::getMainNumber, mainNumber)
                .eq(MarkQuestionAnswer::getSubNumber, subNumber);
        this.update(updateWrapper);
    }

    @Override
    public List<MarkQuestionAnswer> listByExamIdAndPaperNumberAndPaperType(Long examId, String paperNumber, String paperType) {
        return this.baseMapper.listByExamIdAndPaperNumberAndPaperType(examId, paperNumber, paperType);
    }

    @Override
    public int countByExamIdAndPaperNumber(Long examId, String paperNumber) {
        QueryWrapper<MarkQuestionAnswer> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(MarkQuestionAnswer::getExamId, examId)
                .eq(MarkQuestionAnswer::getPaperNumber, paperNumber);
        return this.count(queryWrapper);
    }
}
