package com.qmth.teachcloud.obe.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.teachcloud.common.bean.dto.DataPermissionRule;
import com.qmth.teachcloud.obe.been.report.StudentCourseInfoDto;
import com.qmth.teachcloud.obe.been.report.StudentRequirementInfoDto;
import com.qmth.teachcloud.obe.entity.TRExamStudent;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * <p>
 * 报告考生表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2024-02-18
 */
public interface TRExamStudentMapper extends BaseMapper<TRExamStudent> {

    List<StudentCourseInfoDto> listStudentCourseByCultureProgramIdAndStudentCodeAndSemesterId(@Param("cultureProgramId") Long cultureProgramId, @Param("studentCode") String studentCode, @Param("semesterId") Long semesterId);

    IPage<StudentRequirementInfoDto> requirementStudentPage(@Param("studentRequirementInfoDtoPage") Page<StudentRequirementInfoDto> studentRequirementInfoDtoPage, @Param("cultureProgramId") Long cultureProgramId, @Param("studentCodeOrName") String studentCodeOrName, @Param("dpr") DataPermissionRule dpr);
}
